#!/bin/bash

# Taken from Tushar Teredesai's prelink hint

# Dry run
mkdir -p /root/prelink &&
cd /root/prelink &&
echo "Doing a dry run..."
prelink -avmnR 2>/dev/null > dry-run &&

# Backup
echo "Making backups..."
cat dry-run | grep "Would prelink" | sed -e "s:Would prelink ::" > bkup &&
for f in `cat bkup`
do
	d=`dirname ${f}` 
	install -d /root/prelink${d} 
	cp -av $f /root/prelink${f}
done &&

# Do the actual prelinking
echo "Prelinking..."
prelink -avmR 2>&1 > log
echo "Done."
